About Star-TEC and CircuitWorks

About Star-TEC and CircuitWorks Software

Star-TEC Software provides high quality, affordable software tools to enhance the power of your Electronic and Mechanical CAD systems.

CircuitWorks adds in to SolidWorks and allows it to read and write the industry standard IDF 2.0, 3.0 or 4.0 format files produced by Electrical CAD (ECAD) systems used for Printed Circuit Board (PCB) design

The Star-TEC CircuitWorks Translator enables you to export an IDF file from Cadstar for Windows © that is ready to read into SolidWorks via the CircuitWorks interface.
Using the Program

Find out how to use the CircuitWorks Cadstar-IDF Translator
Data Formats and Specifications

List the program and data formats supported by this program
Error Messages

List the warnings and error messages output by the program, their probable cause and how to resolve them


Export IDF

The CircuitWorks Cadstar-IDF program allows you to create a 3D design file which can be exported to SolidWorks. The Cadstar-IDF program generates an IDF format Layout file and Library file from the current Cadstar for Windows PCB Layout file.

The Layout file contains:

  • The Board profile, including all cutouts, generated from the Board Outline shape in the source PCB Layout.
  • A list of Drilled Holes for each Component with a Hole attribute (see Notes below)
  • A list of Parts plus details of their location, orientation, Fix status and reference designation.

If you have already created equivalent Part models in the CircuitWorks translator, this file may contain sufficient information to build the PCB assembly.

The Library File contains:

  • A description of each Part/Component type which meets the translation criteria.

Note:

Only those components that have a closed shape on the specified layer are output. The height attribute assigned to the Part or Component is used to extrude the shape into a 3D model.

IDF Version

Select to export data in either IDF2.0 or IDF3.0 format.If you select IDF3.0 then the program check if Parts have a ‘ZOffset’ attribute. If found then the value of this attribute is applied as the Mounting Offset, the height of the bottom of the component above the board surface (or below the board surface if mirrored).

Units

Select the export units for the output files. You can select to use either ‘Thou’ or ‘mm’.

Layers for component outlines

Select the layers from which to generate the component model shapes. You must specify a separate layer for the Min (top) and Max (bottom) sides of the board.

  • The layers you select must contain a Closed component outline shape.
  • The layers you select will normally be a swap pair (e.g. ‘Top Placement’ and ‘Bottom Placement’) to ensure that the same shape is used if a Part is used on both sides of the board.

Output File Names

The output file names are set to the same stem name as the current PCB Layout file with .EMN and .EMP extensions.

You can choose whether to output a report file that includes a list of components plus an indication of their transfer status.

If you see the message ‘WARNING: No Library item generated for Part .. ‘ this indicates that either the component has no outline on the specified layer or the outline is not a closed shape.

Text Formatting

To ensure that Part and Component names that contain non-standard characters can be read into SolidWorks, text is formatted as follows:

Replace Spaces

· Spaces in Part, Component and Component Alternate names are replaced with underscore characters. The space character is reserved as a field delimiter in the IDF format so must be replaced with an alternate character.

Wrap Names in Quote Marks

· Part and Component names will be enclose in quote marks. This allows names to be output that includes characters (e.g. / , . * etc.) which would invalidate the IDF format restrictions.

Note

If Part names have not been defined for any components, the program automatically allocates the name as ‘NO_PART_n’ where ‘n’ is a sequential number.

Exclude Parts with ‘hole’ attribute

Do not output Parts with a component attribute called ‘hole’. This allows hole parts in Cadstar to be exported as Drilled Holes in the Board Outline and not listed in the IDF Layout file.

Exclude Name Stems

Do not output any Parts with a name stem listed in one of the Name Stem fields. This enables you to block the export of Testpoint, Holes, discrete components or other classes or Part.

Output Drilled Holes

Output components with a ‘hole’ attribute in the Drilled Holes section of the IDF file. Use this option to output the holes of fixing components without having to include the component in the list of Parts.

To Use This Option:
  • Create a Component-type attribute with the name of ‘hole’
  • Add the attribute to those components (e.g. Fixing Hole components) for which you wish to output the hole as a board cutout without having to generate a Part reference. Set the Value of the attribute to the hole diameter in mm.
  • You can also specify a hole attribute and hole size in the Parts library entry for the fixing hole so that all Fixing Holes are automatically assigned the correct value
  • Enable the ‘Output Drilled Holes’ option and specify the name stem of the hole component in the ‘Exclude name stems’ option.

Set Default Height

Any Part that has a Height attribute of zero (0) will be assigned the specified value.

Height Attribute

Enter the name of the component attribute that contains the height value. The default name is ‘height’. The attribute name in not case sensitive.

Board Thickness

Enter a value for the thickness of the PCB. The default value is 1.6mm or it’s equivalent in the selected unit.

AutoGenerate Shapes

Automatically generate a boundary shape for any parts without a closed shape on the specified layers.

NOTE that if the part has no outlines on any layer then a shape is not generated; these are assumed to be board features such as Holes or Fiducials.

Single Pin Comps to Drilled Holes

Convert single pin components to Drilled Holes in the board.

Start Processing

Start processing the current PCB Layout to generate the IDF output files.

Component Names

Cadstar allows the definition of Component Names with unlimited Alternates. When creating IDF data the Cadstar-IDF program creates the Package name by appending the Stem and Alternate component names using an underscore character to delimit the text strings.

E.g. Component Stem name: SOIC16

Alternate name: wide

Package name: SOIC16_wide


Before You Start...

Check which components have outlines with closed outline shapes

· In the Cadstar Design Editor select a component outline, then select Edit Component from the Library menu. The component will be loaded into the Component editor.

· Change the Colour settings if necessary so that the relevant layers are visible.

· Select any part of the component outline and select Query (Item Properties from Cadstar 4.0 ) from the Edit menu.

· Ensure that the Closed option is checked; if it is not, check the option and select OK. If the shape will not close it may be a self-intersecting shape; if so, resolve the intersecting segments and try again.

· Save the component to the PCB Component library.

· Use the 'Reload from Library' function to update all components in the current design.

Check that Parts / Components have a height attribute assigned.

· Select a Part in the source Cadstar file, then select Query from the Edit menu.

· Choose the Attributes button.

· If the button is greyed out then the Part does not have any attributes assigned.

· Select the Attribute Names popdown and choose ‘height‘ from the list. The value will be displayed in the Attribute Value field.

  • If there is no ‘height’ attribute then it has not yet been defined.

Click here for details on how to add a height attribute


Add A Height Attribute

Adding Height Attributes

Cadstar component attributes are used to assign a value for the height of Parts so that the Cadstar-IDF program can convert them into 3D models. The height attribute can be added to the Part definition in the Cadstar Part library, or added directly to a Part or Component in a PCB Layout file.

To create a Height Attribute

· Select the Attribute Names option from the Settings menu.

· Check the list of available attributes for an ‘Attribute Of’ class of ‘Components’

· If a ‘height’ attribute exists you are ready to add it to a Part or Component

· If no height attribute exists, select the Add button, enter an Attribute Name of ‘height’, assign an ‘Attribute Of’ class of ‘Components’ and set the ‘Valid Design Types’ option to ‘All Design Types’

· If the ‘Attribute Of’ class is set to any class other than ‘Component’ you should delete the attribute and re-enter it

Notes

· The Export IDF module is not case sensitive to the height attribute, so you can use height, HEIGHT, Height or any other combination of upper and lower case characters.

· You can use another name for the height attribute (e.g. COMP_HEIGHT) but you will have to enter this name every time you run the Export IDF program.

To Add an Attribute to a Part

· Select the Add Attribute function.

· Choose ‘Components’ from the ‘Attribute Of’ popdown and ‘height’ from the ‘Attribute Name’ popdown.

· Enter a value in the ‘Text String’ field. The data you enter is treated as a text string so be careful not to add unnecessary space or carriage return characters.

· Select the OK button, then pick each Part or Component in turn to assign the attribute value.

Notes

The target mechanical system reads the height value in the current unit so a value of ‘5’ could be 5mm or 0.005”. For consistency always use the same unit and preferably enter the height attributes in the Parts library.

If you assign different height values to a number of Parts or Components of the same type, only the first value found by the program will be used. This occurs because only one Part definition is allowed in the IDF Library file.


Options Menu

The Options menu contains controls for the program that are stored in the INI file and restored whenever you start the program.

Always on Top

Display the CircuitWorks Cadstar-IDF application on top of all other windows. This ensures that the Cadstar-IDF translator application is always visible.

Large Fonts

Re-size the application dialogs when using the ‘large fonts’ option on your desktop. Dialogs are generally larger when Large Fonts is enabled because the text on butons and labels use more screen area.

Update INI File

Write the current settings to the INI control file so they are preset the next time you start the CircuitWorks Cadstar-IDF application


Data Formats

Data Formats and Limitations

Operating Systems

Windows NT 4.0, 2000, XP or Vista is required. This program does not support Windows 3.1or 3.11 and is not warranted on Windows 95 or Windows 98.

Cadstar for Windows

Cadstar for Windows 3.0.1 or later is required. Versions up to Cadstar 9 have been tested.

Export IDF

The Export IDF module generates either IDF 2.0 or IDF3.0 format, dependant on the requirements of the target MCAD system. The CircuitWorks interface for Solidworks will read both 2.0 and 3.0 formats.

IDF 3.0 provides additional functionality to offset components / parts from the board surface. If a component / part has a Component attribute with the name of ‘offset’ then the value of the attribute will be output as the offset from the board surface.


Error Messages

Warning and Error Messages

“The Cadstar OLE Server cannot be found. Please check that Cadstar 3.0.1 is running”

Cause:

· The Cadstar-IDF Translator could not find a running copy of Cadstar for Windows.

Solutions:

· Start the Cadstar for Windows application. Select the About option from the Help menu and ensure that the version is 3.0.1 or later.

· Check that a PCB Design is loaded and is the current window.

“No Cadstar design open. Please open a design and try again”

Cause:

· Cadstar for Windows is running but there is no design open.

Solution:

· Open a PCB Design then restart the Cadstar-IDF application.

“The current window is a xxxxxx. Please open a PCB file”

Cause:

· The current Cadstar window is a Schematic, Schematic Symbol, PCB Component or Documentation Symbol that do not contain valid data for the Cadstar-IDF application.

Solution:

Open a PCB Design then restart the Cadstar-IDF application.